playlistsite/urls.py
from django.contrib import admin
from django.urls import path, include, reverse_lazy
from django.views.generic.base import RedirectView
from django.contrib.auth import views as auth_views
from songs.views import sign_up

urlpatterns = [
    path('admin/', admin.site.urls),
    path('songs/', include("songs.urls")),
    path('', RedirectView.as_view(url=reverse_lazy("home"))),
    path("login/", auth_views.LoginView.as_view(), name="login"),
    path(
        "logout/",
        auth_views.LogoutView.as_view(),
        name="logout",
    ),
    path("signup/", sign_up, name="sign_up"),
]

songs/urls.py
from django.contrib import admin
from django.urls import path
from django.contrib.auth import views as auth_views

from songs.views import(
    SongsListView,
    SongsCreateView,
    PlaylistListView,
    PlaylistCreateView,
    PlaylistDetailView,
    ArtistListView,
    ArtistCreateView,
    ArtistDetailView,
    search_songs
)

urlpatterns = [
    path("", SongsListView.as_view(),name="home"),
    path("add/", SongsCreateView.as_view(),name="add_song"),
    path("playlist/", PlaylistListView.as_view(), name="all_playlists"),
    path("playlist/new/", PlaylistCreateView.as_view(), name="new_playlist"),
    path("playlist/<int:pk>/",PlaylistDetailView.as_view(), name="playlist_details"),
    path("artists/", ArtistListView.as_view(), name="all_artists"),
    path("artists/add/", ArtistCreateView.as_view(), name="new_artist"),
    path("artists/<int:pk>/", ArtistDetailView.as_view(), name="artist_detail"),
    path("login/", auth_views.LoginView.as_view(), name="login"),
    path("logout/", auth_views.LogoutView.as_view(), name="logout"),
    path("search_songs/", search_songs, name="search-songs"),
]

songs/models.py
from django.db import models
from django.conf import settings

USER_MODEL = settings.AUTH_USER_MODEL

# Create your models here.
class Song(models.Model):
    name = models.CharField(max_length=80)
    artist = models.ForeignKey(
        "Artist",
        related_name="songs",
        on_delete=models.CASCADE,
        null=True,
    )
    image = models.URLField(null=True, blank=True)
    album = models.ForeignKey(
        "Album",
        related_name="songs",
        on_delete=models.CASCADE,
        null=True,
        blank=True,
    )
  

    # this updates the name in the admin
    def __str__(self):
        return self.name
    

class Artist(models.Model):
    name = models.CharField(max_length=50)
    # album = models.ForeignKey(
    #     "Albums",
    #     related_name="album",
    #     on_delete=models.CASCADE,
    #     null=True,
    # )

    # this updates the name in the admin
    def __str__(self):
        return self.name

class Album(models.Model):
    name = models.CharField(max_length=50)
    record_label = models.CharField(max_length=50)


class Playlist(models.Model):
    name = models.CharField(max_length=50)
    owner = models.ForeignKey(
        USER_MODEL,
        related_name="playlist",
        on_delete=models.CASCADE,
        null=True,
    )
    song = models.ManyToManyField(
        "Song",
        related_name="songs",
        null=True,
        blank=True,
    )

    def __str__(self):
        return self.name
    

songs/views.py
from django.shortcuts import render
from django.views.generic.list import ListView
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView
from django.urls import reverse_lazy
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth import login

from songs.models import Song, Artist, Album, Playlist
# Create your views here.

class SongsListView(ListView):
    model = Song
    template_name = "songs/list.html"


class SongsCreateView(CreateView):
    model = Song
    template_name = "songs/new.html"
    fields = ["name","artist","album","image"]
    
    def get_success_url(self):
        return reverse_lazy("home")
    
    def form_valid(self, form):
        form.instance.author = self.request.user
        return super().form_valid(form)

class ArtistListView(ListView):
    model = Artist
    template_name = "artists/list.html"
    fields = ["name"]


class ArtistCreateView(CreateView):
    model = Artist
    template_name = "artists/new.html"
    fields = ["name"]

    def get_success_url(self):
        return reverse_lazy("all_artists")


class ArtistDetailView(DetailView):
    model = Artist
    template_name = "artists/detail.html"
    fields = ["name", "song"]
    success_url = reverse_lazy("home")


class PlaylistListView(ListView):
    model = Playlist
    template_name = "playlists/list.html"


class PlaylistCreateView(CreateView):
    model = Playlist
    template_name = "playlists/new.html"
    fields = ["name", "owner","song"]

    def get_success_url(self):
        return reverse_lazy("all_playlists")

class PlaylistDetailView(DetailView):
    model = Playlist
    template_name ="playlists/detail.html"
    fields = ["name", "owner", "song"]

    def get_success_url(self):
        return reverse_lazy("all_playlists")

class AlbumListView(ListView):
    model = Album


class AlbumCreateView(CreateView):
    model = Album


def sign_up(request):
    if request.method == "POST":
        form = UserCreationForm(request.POST)
        if form.is_valid():
            usernameAPP = request.POST.get("username")
            passwordAPP = request.POST.get("password1")
            # User is a model with a function create_user
            # setting our variables usernameAPP and passwordAPP
            # to the create_user parameters
            user = User.objects.create_user(
                username=usernameAPP, password=passwordAPP
            )
            user.save()
            login(request, user)
            return render(request, "home")
    else:
        form = UserCreationForm(request.POST)
    context = {"form": form}
    return render(request, "registration/sign_up.html", context)


def search_songs(request):
    if request.method == "POST":
        searched = request.POST.get('searched')
        songs = Song.objects.filter(name__contains=searched)
        artists = Artist.objects.filter(name__contains=searched)
        playlists = Playlist.objects.filter(name__contains=searched)
        return render(request, 'songs/search.html',
        {'searched':searched, 'songs':songs, 'artists':artists, 'playlists':playlists})
    else:
        return render(request, 'songs/search.html',
        {})

songs/templates/artists/detail.html
{% extends 'base.html' %}

{% block content %}
<h1>{{ artist.name }}</h1>
<ol>
    {% for song in artist.songs.all %}
    <li>{{ song.name }}</li>
    {% endfor %}
</ol>
            

{% endblock content %}

songs/templates/artists/list.html
{% extends 'base.html' %}

{% block content %}
<h1>Artists</h1>
<ol>
    {% for artist in artist_list %}
        <li><a href="{% url 'artist_detail' artist.id %}">{{ artist.name }}</a></li>
    {% endfor %}
</ol>

{% endblock content%}

songs/templates/artists/new.html
{% extends 'base.html' %}

{% block content %}
<h1>Add Artists</h1>
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button class="button" type="submit">Create</button>
</form>
{% endblock content%}

songs/templates/base.html
{% load static %}

<!DOCTYPE html>
<html>
    <head>
        <title>Playlists</title>
        <link rel="stylesheet" href="/static/css/app.css?{% now "U" %}"/>
    </head>
    <body>
        <nav class="topnav">
            <th>
                {% if user.is_authenticated %}
                <tr>
                    <a href="{% url 'logout' %}">Logout</a>
                {% else %}
                    <a href="{% url 'login' %}">Login</a>
                {% endif %}
                </tr>
                <tr>
                    <a href="{% url 'home' %}">Songs</a>
                </tr>
                <tr>
                    <a href="{% url 'add_song' %}">Add Song</a>
                </tr>
                <tr>
                    <a href="{% url 'all_artists' %}">Artists</a>
                </tr>
                <tr>
                    <a href="{% url 'new_artist'%}">Add Artist</a>
                </tr>
                <tr>
                    <a href="{% url 'all_playlists' %}">Playlists</a>
                </tr>
                <tr>
                    <a href="{% url 'new_playlist' %}">Add Playlist</a>
                </tr>
                <tr>
                    <form method="post" action="{% url 'search-songs' %}">
                        {% csrf_token %}
                        <input type="search" placeholder="Search Songs" aria-label="Search" name="searched">
                        <button class="btn btn-outline-secondary" type="submit">Search</button>
                </tr>
            </th>
        </nav>
        <main>
            {% block content %}
            {% endblock content %}
        </main>
        <footer>
            <p></p>
            Playlist created by {{ playlist.owner }}
        </footer>
    </body>
</html>

songs/templates/playlists/detail.html
{% extends 'base.html' %}

{% block content %}
<h1>{{ playlist.name }}</h1>
<ol>
    {% comment %} for X in playlist.songs.all {% endcomment %}
    {% for song in playlist.song.all %}
    <li> {{ song.name }} </li>
    {% endfor %}
</ol>       

{% endblock content %}

songs/templates/playlists/list.html
{% extends 'base.html' %}

{% block content %}
<h1>Playlists</h1>
<table>
    <thead>
        <tr>
            <th>Playlist Name</th>
            <th>Created by</th>
            <th>Song count</th>
        </tr>
    </thead>
    <tbody>
        {% for playlist in playlist_list %}
        <tr>
            <td><a href="{% url 'playlist_details' playlist.id %}">{{ playlist.name }}</a></td>
            <td>{{ playlist.owner }}</td>
            <td>{{ playlist.song.all|length }}</td>
        </tr>
        {% endfor %}
    </tbody>
</table>
            

{% endblock content %}

songs/templates/playlists/new.html
{% extends 'base.html' %}

{% block content %}
<h1>Create Playlist</h1>
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button class="button" type="submit">Create</button>
</form>
{% endblock content%}

songs/templates/songs/list.html
{% extends 'base.html' %}

{% block content %}

<h1>Songs</h1>

{% comment %} building as a grid {% endcomment %}
<div class="song-grid">
{% for song in song_list %}
    <div class="song-item">
        <div class="song-title">{{ song.name }}</div>
        <div class="song-artist">{{ song.artist }}</div>
        {% if song.album == None %}
        {% else %}
        <div>{{ song.album }}</div>
        {% endif %}
        <div><img src="{{ song.image }}" class="small-image"></div>
    </div>
{% endfor %}
</div>
{% endblock content %}

songs/templates/songs/new.html
{% extends 'base.html' %}

{% block content %}
<h1>Add Song</h1>
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button class="button" type="submit">Add</button>
</form>
{% endblock content%}

songs/templates/songs/search.html
{% extends 'base.html' %}

{% block content %}
    <left>
    {% if searched %}
        <h1>You searched for {{ searched }}</h1>
        <br/>
        {% for song in songs %}
            <a href="{% url 'song_detail' song.id %}">{{ song }}</a><br/>
        {% endfor %}
        {% for artist in artists %}
            <a href="{% url 'artist_detail' artist.id %}">{{ artist }}</a></br>
            <ol>
                {% for song in artist.songs.all %}
                <li>{{ song }}</li>
                {% endfor %}
            </ol>
        {% endfor %}
        {% for playlist in playlists %}
            <a href="{% url 'playlist_detail' playlist.id %}">{{ playlist }}</a></br>
        {% endfor %}
    {% else %}
        <h1>You forgot to search for a song...</h1>
    {% endif %}
    </left>
{% endblock content %}